
local Config = {}

Config.DJPositions = {
	{
		name = 'bahama',
		pos = vector3(-1381.01, -616.17, 31.5),
		range = 30.0,
		volume = 1.0
	},
	{
		name = 'pantof_albastru',
		pos = vector3(-347.33697509766,170.66825866699,87.10725402832),
		range = 40.0,
		volume = 1.0
	},
	{
		name = 'pantof_verde',
		pos = vector3(4893.5766601563,-4903.814453125,3.4866445064545),
		range = 40.0,
		volume = 1.0
	},
	{
		name = 'biliard',
		pos = vector3(-1581.6583251953,-987.03802490234,13.075123786926),
		range = 30.0,
		volume = 1.0
	},
	{
		name = 'casa_zeph',
		pos = vector3(-1866.3830566406,2069.4670410156,140.99736022949),
		range = 25.0,
		volume = 1.0
	},
    {
        name = 'halloween',
        pos = vector3(-1644.9710693359,-160.17176818848,57.773517608643),
        range = 50.0,
        volume = 1.0
    },
    {
        name = 'djstan',
        pos = vector3(297.23727416992,237.6164855957,105.36650848388),
        range = 100.0,
        volume = 1.0
    }
}


local xSound = exports.xsound

RegisterNetEvent("myDJ:receiveRunningSongs", function(DJPositions)
	if DJPositions ~= nil then
		for k, v in pairs(DJPositions) do
			if v.currentData ~= nil then
				playSong(v.name, v.pos, v.range, v.currentData.currentLink)
				isMusicPaused = false

				if xSound:soundExists(v.name) then
					xSound:setTimeStamp(v.name, v.currentData.currentTime)
					if not v.currentData.currentlyPlaying then
						startStopSong(v.name)
					end
				end

			end
		end
	end
end)

local isNearDJ = false
local isAtDJ = false
local currentDjId = 0
local currentDJ = Config.DJPositions[1]
local nearDjId = 0
local isSongRunning = true
local isMusicPaused = false


Citizen.CreateThread(function()

	while true do

		local playerPed = PlayerPedId()
		local playerCoords = GetEntityCoords(playerPed, true) 

		isAtDJ = false
		isNearDJ = false
		currentDjId = 0
		nearDjId = 0

		for k, v in pairs(Config.DJPositions) do
			local distance = Vdist(playerCoords, v.pos.x, v.pos.y, v.pos.z)

			if distance < 2.0 then
				currentDJ = v
				isAtDJ = true
				isNearDJ = true
				currentDjId = k
			elseif distance < 25.0 then
				isNearDJ = true
				currentDJ = v
				nearDjId = k
			end
		end

		Citizen.Wait(2500)
	end

end)

local djCooldowns = {}
local selfOpened = 0

RegisterNetEvent("plesDjCb:useDj", function(djId, name)
	if selfOpened ~= djId then
		djCooldowns[djId] = GetGameTimer() + 20000
	end

	if nearDjId == djId then
		ShowNotification("~b~"..name.." ~w~ a intrat la masa de DJ")
	end

	selfOpened = 0
end)

Citizen.CreateThread(function()
	while true do
		local biSleep = 500
			local playerPed = PlayerPedId()
			local playerCoords = GetEntityCoords(playerPed, true) 
	
			isAtDJ = false
			isNearDJ = false
			currentDjId = 0
			nearDjId = 0
	
			for k, v in pairs(Config.DJPositions) do
				local distance = Vdist(playerCoords, v.pos.x, v.pos.y, v.pos.z)
	
				if distance < 2.0 then
					biSleep = 3
					dumpaiureabai(0.5, 0.90, 0,0, 0.55, "~w~Apasa ~b~E ~w~pentru a deschide ~b~MYDJ", 255, 255, 255, 230, 1, 4, 1)
					currentDJ = v
					isAtDJ = true
					isNearDJ = true
					currentDjId = k

			if IsControlJustReleased(0, 38) then
				if (djCooldowns[currentDjId] or 0) < GetGameTimer() then
					-- open DJ Interface
					SetNuiFocus(true, true)
					isDjOpen = true
					SendNUIMessage({type = 'open'})
					TriggerServerEvent("plesDj:useDj", currentDjId)
					selfOpened = currentDjId
				else
					ShowNotification('~r~Asteapta pana sa poti pune si tu o melodie')
				end
				end
			end
		end
		Citizen.Wait(biSleep)
	end
end)

RegisterNetEvent('myDj:open')
AddEventHandler('myDj:open', function()
	SetNuiFocus(true, true)
	isDjOpen = true
	SendNUIMessage({type = 'open'})
end)

-- sync timestamps
Citizen.CreateThread(function()
	while true do

		if currentDJ ~= nil then
			if xSound ~= nil and xSound:soundExists(currentDJ.name) then
				
				if xSound:isPlaying(currentDJ.name) then
					SendNUIMessage({type = 'updateSeconds', maxDuration = xSound:getMaxDuration(currentDJ.name), secs = xSound:getTimeStamp(currentDJ.name)})
				end
			end
		end

		Citizen.Wait(1000)
	end
end)

function playSong(DJName, DJPos, DJRange, songlink)
	local options =
	{
		onPlayStart = function(event) -- event argument returns getInfo(id)
			--print("oh yeah! PARTY!")
		end,
		onPlayEnd = function(event) 
			--print("oh... already end ? :( Song name ? pls")
			--print(event.url)
		end,
	}   

	xSound:PlayUrlPos(DJName, songlink, 1, DJPos, false, options)
	xSound:Distance(DJName, DJRange)
	SendNUIMessage({type = 'updateSonginfos', link = songlink})
end

function startStopSong(DJName)

	if xSound:soundExists(DJName) and isMusicPaused then
		xSound:Resume(DJName) 
		isMusicPaused = false
	elseif xSound:soundExists(DJName) and not isMusicPaused then
		xSound:Pause(DJName)
		isMusicPaused = true

	end

end

function stopSong(DJName)
	xSound:Destroy(DJName) 
end

function rewindSong(DJName)
	if currentDJ ~= nil then
		if xSound:soundExists(DJName) then
			if xSound:isPlaying(DJName) then
				local currTimestamp = xSound:getTimeStamp(DJName)
				if currTimestamp - 10 < 0 then
					xSound:setTimeStamp(0)
				else
					xSound:setTimeStamp(DJName, currTimestamp - 10)
				end
				
			end
		end
	end
end

function forwardSong(DJName)
	if currentDJ ~= nil then
		if xSound:soundExists(DJName) then
			if xSound:isPlaying(DJName) then
				local currTimestamp = xSound:getTimeStamp(DJName)
				xSound:setTimeStamp(DJName, currTimestamp + 10)
			end
		end
	end
end

function volumeUp(DJName)
	if xSound:soundExists(DJName) then
		if currentDJ.volume + 0.1 >= 1 then
			currentDJ.volume = 1.0
			xSound:setVolume(DJName, 1.0)
			--ShowNotification('~g~Maximum volume reached')
		else
			currentDJ.volume = currentDJ.volume + 0.1
			xSound:setVolume(DJName, currentDJ.volume + 0.1)
			--ShowNotification('~g~Volume set to: ' .. (currentDJ.volume + 0.1) * 100 .. '%')
		end
		
	end
end

function volumeDown(DJName)
	if xSound:soundExists(DJName) then

		local currentVolume = 1.0

		for k,v in pairs(Config.DJPositions) do
			if v.name == DJName then
				currentVolume = v.volume
			end
		end

		if currentDJ.volume - 0.05 <= 0 then
			currentDJ.volume = 0.0
			xSound:setVolume(DJName, 0.0)
			--ShowNotification('~g~Minimum volume reached')
		else
			currentDJ.volume = currentDJ.volume - 0.05
			xSound:setVolume(DJName, currentDJ.volume - 0.05)
			--ShowNotification('~g~Volume set to: ' .. (currentDJ.volume - 0.1) * 100 .. '%')
		end
		
	end
end

RegisterCommand('openDJ', function(source, args, rawCommand)
	SetNuiFocus(true, true)
	isDjOpen = true
	SendNUIMessage({type = 'open'})
	UTKFleeca.RegisterServerCallback('myDJ:requestPlaylistsAndSongs', function(playlists, songs)
		SendNUIMessage({type = 'getPlaylists', playlists = playlists, songs = songs})
	end)
end, false)

RegisterNUICallback('close', function(data, cb) 
	SetNuiFocus(false, false)
	isDjOpen = false
end)

RegisterNetEvent('myDj:clientStartStop')
AddEventHandler('myDj:clientStartStop', function(DJName)
	startStopSong(DJName)
end)

RegisterNUICallback('togglePlaystate', function(data, cb)
	TriggerServerEvent('myDj:syncStartStop', currentDJ.name)
end)

RegisterNetEvent('myDj:clientPlaySong')
AddEventHandler('myDj:clientPlaySong', function(DJName, DJPos, DJRange, link)
	playSong(DJName, DJPos, DJRange, link)
	isMusicPaused = false
end)

RegisterNUICallback('playNewSong', function(data, cb) 
	if string.len(data.link) <= 100 then
	TriggerServerEvent('myDj:syncPlaySong', currentDJ.name, currentDJ.pos, currentDJ.range, data.link)
	else
		print("O muie nu vrei tu?")
	end
end)

RegisterNetEvent('myDj:clientRewind')
AddEventHandler('myDj:clientRewind', function(DJName)
	rewindSong(DJName)
end)

RegisterNUICallback('rewind', function(data, cb)
	TriggerServerEvent('myDj:syncRewind', currentDJ.name)
end)

RegisterNUICallback('setTimeStampProcent', function(data)
	TriggerServerEvent("myDJ:setTimeStampProcent", currentDJ.name, data.val)
end)

RegisterNetEvent("myDJcl:setTimeStampProcent", function(name, val)
	xSound:setTimeStamp(name, (xSound:getMaxDuration(name) / 100) * (val or 0))
end)

RegisterNetEvent('myDj:clientForward')
AddEventHandler('myDj:clientForward', function(DJName)
	forwardSong(DJName)
end)

RegisterNUICallback('forward', function(data, cb)
	TriggerServerEvent('myDj:syncForward', currentDJ.name)
end)

RegisterNetEvent('myDj:clientVolumeDown')
AddEventHandler('myDj:clientVolumeDown', function(DJName)
	volumeDown(DJName)
end)

RegisterNUICallback('down', function(data, cb)
	-- leiser machen
	TriggerServerEvent('myDj:syncVolumeDown', currentDJ.name)
	if currentDJ.volume <= 0.0 then
		ShowNotification('~g~Minimum volume reached!')
	end
end)

RegisterNetEvent('myDj:clientVolumeUp')
AddEventHandler('myDj:clientVolumeUp', function(DJName)
	volumeUp(DJName)
end)

RegisterNUICallback('up', function(data, cb)
	-- lauter machen
	TriggerServerEvent('myDj:syncVolumeUp', currentDJ.name)
	if currentDJ.volume >= 1.0 then
		ShowNotification('~g~Volum maxim !')
	end
end)

RegisterNUICallback('noSongtitle', function(data, cb)
	ShowNotification("~r~Piesa nu a fost gasita")
end)


function ShowNotification(text)
	SetNotificationTextEntry('STRING')
	AddTextComponentString(text)
	DrawNotification(false, true)
end

function dumpaiureabai(x,y ,width,height,scale, text, r,g,b,a, outline, font, center)
    SetTextFont(4)
    SetTextProportional(0)
    SetTextScale(scale, scale)
    SetTextColour(r, g, b, a)
    SetTextDropShadow(0, 0, 0, 0,255)
    SetTextEdge(1, 0, 0, 0, 255)
    SetTextDropShadow()
    SetTextCentre(center)
    if(outline)then
        SetTextOutline()
    end
    SetTextEntry("STRING")
    AddTextComponentString(text)
    DrawText(x - width/2, y - height/2 + 0.005)
end